#include <lists.h>

void *list_append(void *vp, void *vstart)
{
	p_list_head p=(p_list_head)vp;
	p_list_head tmp=(p_list_head)vstart;
	
	if ( tmp ) {
		while(tmp->next)
			tmp=tmp->next;

		tmp->next = p;
		p->prev = tmp;
		p->next = NULL;
		return (void *)vstart;
	}else{
		p->prev = NULL;
		p->next = NULL;
		return (void *)p;
	}
}

/* If you remove the first item in a list and then
* free and NULL it, you orphan the whole list  */
void *list_remove(void *p)
{
	p_list_head node=(p_list_head)p;
	
	if ( node->prev ) node->prev->next = node->next;
	if ( node->next ) node->next->prev = node->prev;
	return (void *)node;
}

void *list_prepend(void *vp, void *vstart)
{
	p_list_head p=(p_list_head)vp;
	p_list_head start=(p_list_head)vstart;

	start->prev = p;
	p->next = start;
	p->prev = NULL;

	return (void *)p;
}
